/**************************************************************************************
	Wance Tool Client
	File : 	wance_func.c

**************************************************************************************/


#include	"inet.h"	

#define	MAXLINE	512

tvsub(register struct timeval *out, register struct timeval *in)
{
	if ( (out->tv_usec -= in->tv_usec) < 0) {	/* subtract microsec */
		out->tv_sec--;
		out->tv_usec += 1000000;
	}
	out->tv_sec -= in->tv_sec;	/* subtract seconds */
}

dg_cli(fp, sockfd, pserv_addr, servlen,len, dest)
FILE		*fp;
int		sockfd;
struct sockaddr	*pserv_addr;	/* ptr to appropriate sockaddr_XX structure */
int		servlen;	/* actual sizeof(*pserv_addr) */
int		len;		/* length of message to be sent */
char		*dest;
{
	int	n,i;
	char	*sendline, *recvline;
	char	line[MAXLINE];
	struct sockaddr_in	from_addr;
 	int fromlen, debug=0;
 	struct timeval		in, out;
 	int triptime;
	FILE	*outfp;
	
	if((outfp=fopen("wance.time", "a")) == NULL)
		printf("Error in opening wance.time file\n");

	printf("Press Enter\n");
	while (fgets(line, MAXLINE, fp) != NULL) {
		sendline=malloc(len+1);
		if(sendline==NULL) 	
			{
			printf("Error in Malloc\n"); 
			exit();
			}
		recvline=malloc(len+1);
		if(recvline==NULL) 
			{
			printf("Error in Malloc\n"); 
			exit();
			}
		printf("Preparing Message\n");
		fflush(stdout);
		for(i=0; i<len; i++)
			sendline[i]='a';
		sendline[i]='\0';
		n = strlen(sendline);
		if(debug)
			printf("sockfd = %d\n", sockfd);
		if(debug)
			printf("dgcli: sockfd =%d, recvline = %x fromlen=%d from_addr = %x\n", sockfd, recvline, fromlen, &from_addr);

		gettimeofday(&in, (struct timezone *) 0);
		if (sendto(sockfd, sendline, n, 0, pserv_addr, servlen) != n)
			err_dump("dg_cli: sendto error on socket");

		/*
		 * Now read a message from the socket and write it to
		 * our standard output.
		 */
if(debug)
		{
		printf("Just before recvfrom\n");
		printf("sockfd = %d\n", sockfd);

		printf("dgcli: sockfd =%d, recvline = %x fromlen=%d from_addr = %x\n", sockfd, recvline, fromlen, &from_addr);
		}
		n = recvfrom(sockfd, recvline, n, 0,
				(struct sockaddr *) &from_addr, (int *) &fromlen);
		if (n < 0)
			err_dump("dg_cli: recvfrom error");
		else
			if(debug) printf("returned from recvfrom\n");
		recvline[n] = 0;	/* null terminate */
		printf("Wance Client received %d bytes\n%s\n", n,recvline);
		fflush(stdout);
		gettimeofday(&out, (struct timezone *) 0);
		tvsub(&out, &in);
		triptime = out.tv_sec * 1000 + (out.tv_usec / 1000);
		printf("\n\nTIME=%d. ms\n", triptime);	/* milliseconds */
		fprintf(outfp, "%s	%d. ms\n",dest, triptime);	/* milliseconds */
		fflush(outfp);
		printf("Press Enter\n");
	}

	if (ferror(fp))
		err_dump("dg_cli: error reading file");
}
